#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <omp.h>

void f(double* x, double* y, double*z, int n){
   int i;
   for(i = 0; i < n;++i){
      z[i] += x[i]*x[i]*x[i] * y[i] * 0.3 + .3/.4 * x[i]*x[i] * y[i]*y[i]*y[i] - y[i] * x[i] * .4;
      }
}

int main(int argc, char** argv){

   int i,j;
   int n = 1000000, num_runs = 10;

   //allocate data
   double *x = (double*) malloc(sizeof(double) * n);
   double *y = (double*) malloc(sizeof(double) * n);
   double *z = (double*) malloc(sizeof(double) * n*num_runs);
   for(i = 0; i < n;++i){
      x[i] = 1.01;
      y[i] = 1.02;
      z[i] = 0.0;
   }

   //This looks just so confusing in order to prevent the compiler
   //from removing the outer loop while optimizing
   double start = omp_get_wtime();
   for(i = 0; i < num_runs; ++i)
      f(x,y,&z[i*n],n);
   double end= omp_get_wtime();
   printf("C good: %f\n",end-start);
   
   double sum = 0.0;
   for(j = 0; j < n*num_runs; ++j)
      sum += z[j];
   printf("sum: %f\n",sum);

   free(x);
   free(y);
   free(z);
   return 0;
}
