from numbapro.vectorize import Vectorize
from time import time
from numba import *
import numpy as np

def f(x,y):
    #return x**3 * y *.3 + .3/4. * x**2 * y**3 - y * x *.4
    return x*x*x * y *.3 + .3/4. * x*x * y*y*y - y * x *.4

#allocate data
x=np.linspace(1,10,1e6)
y=np.linspace(1,20,1e6)


v=Vectorize(f)
v.add(restype=f8, argtypes=[f8, f8])
vf = v.build_ufunc()

v=Vectorize(f, target='parallel')
v.add(restype=f8, argtypes=[f8, f8])
vpf = v.build_ufunc()

t2 =time()
[vf(x,y) for i in range(10)];
t3 =time()
[vpf(x,y) for i in range(10)];
t4 =time()

print "numbapro@normal: ", t3-t2
print "numbapro@parallel: ", t4-t3
