from time import time
import numpy as np
import numexpr as ne

def f(x,y):
    return x*x*x * y *.3 + 3./4. * x*x * y*y*y - y * x *.4

#allocate data
n = 1000000
x=np.linspace(1,10,n)
y=np.linspace(1,20,n)

#numpy
t2 = time()
[f(x,y) for i in range(10)]
t3 = time()

#numexpr 1 Thread
ne.set_num_threads(1)
t4 = time()
[ne.evaluate("x*x*x * y *.3 + 3./4. * x*x * y*y*y - y * x *.4") for i in range(10)]
t5 = time()

#numexpr 2 Thread
ne.set_num_threads(2)
t6 = time()
[ne.evaluate("x*x*x * y *.3 + 3./4. * x*x * y*y*y - y * x *.4") for i in range(10)]
t7 = time()

print "numpy(good) impr:", t3-t2
print "numexpr(1):", t5-t4
print "numexpr(2):", t7-t6
